Package com.collabnet.ce.soap60.webservices.docman

# Class DocumentAppSoapStub

java.lang.Object
com.collabnet.ce.soap60.webservices.ClientSoapStub
com.collabnet.ce.soap60.webservices.docman.DocumentAppSoapStub

All Implemented Interfaces:
  `IDocumentAppSoap`

public class DocumentAppSoapStub extends ClientSoapStub implements IDocumentAppSoap

- ## Field Summary

  ### Fields inherited from class com.collabnet.ce.soap60.webservices.ClientSoapStub

  `DEFAULT_CLIENT_TIME_OUT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DocumentAppSoapStub(String soapServerUrl)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addDateField(String sessionId, String projectId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText)`
  Adds a custom Date field to documents.
  `void`
  `addMultiSelectField(String sessionId, String projectId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText)`
  Adds a custom multi select field to documents.
  `void`
  `addSeparator(String sessionId, String projectId, String separatorType, String separatorLabel)`
  Adds a separator to a document root folder.
  `void`
  `addSingleSelectChildField(String sessionId, String projectId, String fieldName, String[] fieldValues, String parentFieldId, SoapNamedValues parentChildFieldValueMap, String helpText)`
  Adds a custom single select field to documents.
  `void`
  `addSingleSelectField(String sessionId, String projectId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText)`
  Adds a custom single select field to documents.
  `void`
  `addTextField(String sessionId, String projectId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern)`
  Adds a custom text field to documents.
  `void`
  `addUserSelectField(String sessionId, String projectId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText)`
  Adds a custom User selection field to documents.
  `DocumentSoapDO`
  `createDocument(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, String fileName, String mimeType, String fileId, String associationId, String associationDesc)`
  Creates a new document with the specified title, description, etc.
  `Document2SoapDO`
  `createDocument2(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileName, String mimeType, String fileId, String associationId, String associationDesc)`
  Creates a new document with the specified title, description, etc.
  `Document3SoapDO`
  `createDocument3(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileName, String mimeType, String fileId, String associationId, String associationDesc, SoapFieldValues flexFields)`
  Creates a new document with the specified title, description, etc.
  `DocumentFolderSoapDO`
  `createDocumentFolder(String sessionId, String parentId, String title, String description)`
  Creates a new document folder with the specified title, description, etc.
  `DocumentSoapDO`
  `createDocumentWithUrl(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, String fileUrl, String associationId, String associationDesc)`
  Creates a new document with the specified title, description, etc.
  `Document2SoapDO`
  `createDocumentWithUrl2(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileUrl, String associationId, String associationDesc)`
  Creates a new document with the specified title, description, etc.
  `Document3SoapDO`
  `createDocumentWithUrl3(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileUrl, String associationId, String associationDesc, SoapFieldValues flexFields)`
  Creates a new document with the specified title, description, etc.
  `DocumentReviewSoapDO`
  `createReview(String sessionId, String documentId, int version, String title, String description, Date dueDate, String[] requiredReviewers, String[] optionalReviewers, boolean attachDocument)`
  Creates a document review cycle
  `void`
  `deleteDocument(String sessionId, String documentId)`
  Deletes a document.Locked document(s) cannot be deleted
  `void`
  `deleteDocumentByVersions(String sessionId, String documentId, int[] versionNumbers)`
  Deletes particular version(s) of a document.Locked document version(s) cannot be deleted
  `void`
  `deleteDocumentFolder(String sessionId, String folderId)`
  Deletes a document folder with the specified id.
  `void`
  `deleteField(String sessionId, String fieldId)`
  Deletes a custom/flex-field.
  `void`
  `deleteSeparator(String sessionId, String layoutId)`
  Deletes a separator of a document root folder layout.
  `DocumentSoapList`
  `findDocuments(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly)`
  Finds a list of documents matching a search string.
  `Document2SoapList`
  `findDocuments2(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly)`
  Finds a list of documents matching a search string.
  `Document3SoapList`
  `findDocuments3(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly)`
  Finds a list of documents matching a search string.
  `DocumentReviewSoapList`
  `getAssignedDocumentReviewList(String sessionId, String username)`
  Lists all document reviews assigned to a user for review.
  `DocumentSoapDO`
  `getDocumentData(String sessionId, String documentId, int documentVersion)`
  Gets specified document data.
  `Document2SoapDO`
  `getDocumentData2(String sessionId, String documentId, int documentVersion)`
  Gets specified document data.
  `Document3SoapDO`
  `getDocumentData3(String sessionId, String documentId, int documentVersion)`
  Gets specified document data.
  `String`
  `getDocumentFileId(String sessionId, String documentId, int documentVersion)`
  Returns a the file id associated with the document file.
  `DocumentFolderSoapDO`
  `getDocumentFolderData(String sessionId, String folderId)`
  Gets detailed data on a document folder
  `DocumentFolderSoapList`
  `getDocumentFolderList(String sessionId, String parentId, boolean recursive)`
  Lists document folders.
  `DocumentSoapList`
  `getDocumentList(String sessionId, String parentId, SoapFilter[] filters)`
  Lists all documents within a document folder.
  `Document2SoapList`
  `getDocumentList2(String sessionId, String parentId, SoapFilter[] filters)`
  Lists all documents within a document folder.
  `Document3SoapList`
  `getDocumentList3(String sessionId, String documentFolderId, SoapFilter[] filters)`
  Lists all documents within a document folder.
  `DocumentReviewSoapList`
  `getDocumentReviewList(String sessionId, String containerId, SoapFilter[] filters)`
  Lists all document reviews within a project or a document.
  `Document2SoapList`
  `getDocumentVersions(String sessionId, String documentId, boolean includeDeletedVersions)`
  Lists all the versions of a document.
  `DocumentFolderFieldSoapDO[]`
  `getFields(String sessionId, String projectId)`
  Returns the custom/flex-fields associated with the given project's document root folder.
  `OrderedDocumentFolderFieldSoapList`
  `getOrderedDocumentFields(String sessionId, String projectId)`
  Returns all the custom/flex-fields and the separators associated with the given project's document root folder with layout information.
  `DocumentSoapDO`
  `moveDocument(String sessionId, String documentId, String targetFolderId)`
  Moves a document to a specified target folder.
  `Document2SoapDO`
  `moveDocument2(String sessionId, String documentId, String targetFolderId)`
  Moves a document to a specified target folder.
  `Document3SoapDO`
  `moveDocument3(String sessionId, String documentId, String targetFolderId)`
  Moves a document to a specified target folder.
  `DocumentFolderSoapDO`
  `moveDocumentFolder(String sessionId, String folderId, String destFolderId)`
  Moves document folder
  `void`
  `reorderDocumentFields(String sessionId, String projectId, String[] layoutIds)`
  Sets a new order of the fields and the separators within the given project's document root folder.
  `void`
  `setDocumentData(String sessionId, DocumentSoapDO documentData, String fileId)`
  Sets specified document data.
  `void`
  `setDocumentData2(String sessionId, Document2SoapDO documentData, String fileId)`
  Sets specified document data.
  `void`
  `setDocumentData3(String sessionId, Document3SoapDO documentData, String fileId)`
  Sets specified document data.
  `void`
  `setDocumentDataWithAssociation(String sessionId, DocumentSoapDO documentData, String fileId, String associationId, String associationComment)`
  Sets specified document data with Association.
  `void`
  `setDocumentDataWithAssociation2(String sessionId, Document2SoapDO documentData, String fileId, String associationId, String associationComment)`
  Sets specified document data with association.
  `void`
  `setDocumentDataWithAssociation3(String sessionId, Document3SoapDO documentData, String fileId, String associationId, String associationComment)`
  Sets specified document data with association.
  `void`
  `setDocumentFolderData(String sessionId, DocumentFolderSoapDO documentFolderData)`
  Sets detailed data on a document folder
  `void`
  `setField(String sessionId, DocumentFolderFieldSoapDO fieldData)`
  Sets a custom/flex-field.

  ### Methods inherited from class com.collabnet.ce.soap60.webservices.ClientSoapStub

  `getServiceCall, getSoapServer, getTimeout, setTimeout, soapParam`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DocumentAppSoapStub

    public DocumentAppSoapStub(String soapServerUrl)

- ## Method Details

  - ### getDocumentFolderList

    public DocumentFolderSoapList getDocumentFolderList(String sessionId, String parentId, boolean recursive) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists document folders.
    Specified by:
      `getDocumentFolderList` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Parent document folder id -or- project id for listing root document folder.
      `recursive` - Show subfolders of the folders returned
    Returns:
      Document folder list.
    Throws:
      `RemoteException`

  - ### setDocumentFolderData

    public void setDocumentFolderData(String sessionId, DocumentFolderSoapDO documentFolderData) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets detailed data on a document folder
    Specified by:
      `setDocumentFolderData` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `documentFolderData` - Data to apply.
    Throws:
      `RemoteException`

  - ### getDocumentFolderData

    public DocumentFolderSoapDO getDocumentFolderData(String sessionId, String folderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Gets detailed data on a document folder
    Specified by:
      `getDocumentFolderData` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `folderId` - Folder id to get detailed data for.
    Returns:
      Document Folder data object.
    Throws:
      `RemoteException`

  - ### getAssignedDocumentReviewList

    public DocumentReviewSoapList getAssignedDocumentReviewList(String sessionId, String username) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all document reviews assigned to a user for review.
    Specified by:
      `getAssignedDocumentReviewList` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `username` - User to whom reviews are assigned for review (required or optional).
    Returns:
      Document review list.
    Throws:
      `RemoteException`

  - ### getDocumentReviewList

    public DocumentReviewSoapList getDocumentReviewList(String sessionId, String containerId, SoapFilter[] filters) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all document reviews within a project or a document.
    Specified by:
      `getDocumentReviewList` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `containerId` - null (for reviews across projects) or document ID (for reviews associated with document).
      `filters` - Filters to apply for listing the reviews.
    Returns:
      Document review list.
    Throws:
      `RemoteException`

  - ### createReview

    public DocumentReviewSoapDO createReview(String sessionId, String documentId, int version, String title, String description, Date dueDate, String[] requiredReviewers, String[] optionalReviewers, boolean attachDocument) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a document review cycle
    Specified by:
      `createReview` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `documentId` - the id of the document for which the review is to be created.
      `version` - the version of the document
      `title` - The title of the review
      `description` - The description of the review
      `dueDate` - The due date of the review
      `requiredReviewers` - an array of usernames of required reviewers
      `optionalReviewers` - an array of usernames of optional reviewers
      `attachDocument` - whether to attach the document to the email or not
    Returns:
      The data object of the review
    Throws:
      `RemoteException`

  - ### getDocumentList

    public DocumentSoapList getDocumentList(String sessionId, String parentId, SoapFilter[] filters) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all documents within a document folder.
    Specified by:
      `getDocumentList` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id (obtained from getDocumentFolderList).
      `filters` - not supported.
    Returns:
      Document list.
    Throws:
      `RemoteException`

  - ### getDocumentList2

    public Document2SoapList getDocumentList2(String sessionId, String parentId, SoapFilter[] filters) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all documents within a document folder.
    Specified by:
      `getDocumentList2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id (obtained from getDocumentFolderList).
      `filters` - not supported.
    Returns:
      Document list.
    Throws:
      `RemoteException`

  - ### getDocumentList3

    public Document3SoapList getDocumentList3(String sessionId, String documentFolderId, SoapFilter[] filters) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all documents within a document folder.
    Specified by:
      `getDocumentList3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `documentFolderId` - Document folder id (obtained from getDocumentFolderList).
      `filters` - not supported.
    Returns:
      Document list.
    Throws:
      `RemoteException`

  - ### findDocuments

    public DocumentSoapList findDocuments(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Finds a list of documents matching a search string.
    Specified by:
      `findDocuments` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `queryString` - Query string.
      `projectId` - The project in which to find documents. (if null, search all projects)
      `searchAttachments` - Whether to search attachments.
      `currentVersionsOnly` - Whether to search only current versions of documents.
    Returns:
      List of documents matching search criteria.
    Throws:
      `RemoteException`

  - ### findDocuments2

    public Document2SoapList findDocuments2(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Finds a list of documents matching a search string.
    Specified by:
      `findDocuments2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `queryString` - Query string.
      `projectId` - The project in which to find documents. (if null, search all projects)
      `searchAttachments` - Whether to search attachments.
      `currentVersionsOnly` - Whether to search only current versions of documents.
    Returns:
      List of documents matching search criteria.
    Throws:
      `RemoteException`

  - ### findDocuments3

    public Document3SoapList findDocuments3(String sessionId, String queryString, String projectId, boolean searchAttachments, boolean currentVersionsOnly) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Finds a list of documents matching a search string.
    Specified by:
      `findDocuments3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `queryString` - Query string.
      `projectId` - The project in which to find documents. (if null, search all projects)
      `searchAttachments` - Whether to search attachments.
      `currentVersionsOnly` - Whether to search only current versions of documents.
    Returns:
      List of documents matching search criteria.
    Throws:
      `RemoteException`

  - ### createDocumentFolder

    public DocumentFolderSoapDO createDocumentFolder(String sessionId, String parentId, String title, String description) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document folder with the specified title, description, etc.
    Specified by:
      `createDocumentFolder` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Folder id in which to create this folder.
      `title` - Document folder title.
      `description` - Document folder description.
    Returns:
      Document Folder data object.
    Throws:
      `RemoteException`

  - ### moveDocumentFolder

    public DocumentFolderSoapDO moveDocumentFolder(String sessionId, String folderId, String destFolderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Moves document folder
    Specified by:
      `moveDocumentFolder` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `folderId` - ID of folder to move.
      `destFolderId` - ID of destination folder
    Returns:
      new document folder
    Throws:
      `RemoteException`

  - ### deleteDocumentFolder

    public void deleteDocumentFolder(String sessionId, String folderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Deletes a document folder with the specified id.
    Specified by:
      `deleteDocumentFolder` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `folderId` - Folder id to delete.
    Throws:
      `RemoteException`

  - ### createDocument

    public DocumentSoapDO createDocument(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, String fileName, String mimeType, String fileId, String associationId, String associationDesc) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocument` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `fileName` - Name of the file.
      `mimeType` - File mime type.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the object associated
      `associationDesc` - The title of the object associated
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### createDocument2

    public Document2SoapDO createDocument2(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileName, String mimeType, String fileId, String associationId, String associationDesc) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocument2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `createDownloadRestricted` - Is document download restricted on create?
      `allowForceUnlock` - Is document admin allowed to edit/download locked document?
      `fileName` - Name of the file.
      `mimeType` - File mime type.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the object associated, can be set to null
      `associationDesc` - The title of the object associated
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### createDocument3

    public Document3SoapDO createDocument3(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileName, String mimeType, String fileId, String associationId, String associationDesc, SoapFieldValues flexFields) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocument3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `createDownloadRestricted` - Is document download restricted on create?
      `allowForceUnlock` - Is document admin allowed to edit/download locked document?
      `fileName` - Name of the file.
      `mimeType` - File mime type.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the object associated, can be set to null
      `associationDesc` - The title of the object associated
      `flexFields` - Flex field values
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### createDocumentWithUrl

    public DocumentSoapDO createDocumentWithUrl(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, String fileUrl, String associationId, String associationDesc) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocumentWithUrl` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `fileUrl` - the file URL of the document
      `associationId` - id of the object to be associated
      `associationDesc` - association comment
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### createDocumentWithUrl2

    public Document2SoapDO createDocumentWithUrl2(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileUrl, String associationId, String associationDesc) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocumentWithUrl2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `createDownloadRestricted` - Is document download restricted on create?
      `allowForceUnlock` - Is document admin allowed to edit/download locked document?
      `fileUrl` - the file URL of the document
      `associationId` - id of the object to be associated
      `associationDesc` - association comment
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### createDocumentWithUrl3

    public Document3SoapDO createDocumentWithUrl3(String sessionId, String parentId, String title, String description, String versionComment, String status, boolean createLocked, boolean createDownloadRestricted, boolean allowForceUnlock, String fileUrl, String associationId, String associationDesc, SoapFieldValues flexFields) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Creates a new document with the specified title, description, etc.
    Specified by:
      `createDocumentWithUrl3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `parentId` - Document folder id in which to create a document.
      `title` - Document title.
      `description` - Document description.
      `versionComment` - Document version comment.
      `status` - Document status.
      `createLocked` - Is document locked on create?
      `createDownloadRestricted` - Is document download restricted on create?
      `allowForceUnlock` - Is document admin allowed to edit/download locked document?
      `fileUrl` - the file URL of the document
      `associationId` - id of the object to be associated
      `associationDesc` - association comment
      `flexFields` - Flex field values
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### moveDocument

    public DocumentSoapDO moveDocument(String sessionId, String documentId, String targetFolderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Moves a document to a specified target folder.
    Specified by:
      `moveDocument` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - ID of document to move.
      `targetFolderId` - Target folder ID.
    Returns:
      New document object.
    Throws:
      `RemoteException`

  - ### moveDocument2

    public Document2SoapDO moveDocument2(String sessionId, String documentId, String targetFolderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Moves a document to a specified target folder.
    Specified by:
      `moveDocument2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - ID of document to move.
      `targetFolderId` - Target folder ID.
    Returns:
      New document object.
    Throws:
      `RemoteException`

  - ### moveDocument3

    public Document3SoapDO moveDocument3(String sessionId, String documentId, String targetFolderId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Moves a document to a specified target folder.
    Specified by:
      `moveDocument3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - ID of document to move.
      `targetFolderId` - Target folder ID.
    Returns:
      New document object.
    Throws:
      `RemoteException`

  - ### deleteDocument

    public void deleteDocument(String sessionId, String documentId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Deletes a document.Locked document(s) cannot be deleted
    Specified by:
      `deleteDocument` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - Document id.
    Throws:
      `RemoteException`

  - ### getDocumentData

    public DocumentSoapDO getDocumentData(String sessionId, String documentId, int documentVersion) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Gets specified document data.
    Specified by:
      `getDocumentData` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - Document id.
      `documentVersion` - Document version number (specify zero for current version).
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### getDocumentData2

    public Document2SoapDO getDocumentData2(String sessionId, String documentId, int documentVersion) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Gets specified document data.
    Specified by:
      `getDocumentData2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - Document id.
      `documentVersion` - Document version number (specify zero for current version).
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### getDocumentData3

    public Document3SoapDO getDocumentData3(String sessionId, String documentId, int documentVersion) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Gets specified document data.
    Specified by:
      `getDocumentData3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - Document id.
      `documentVersion` - Document version number (specify zero for current version).
    Returns:
      Document data object.
    Throws:
      `RemoteException`

  - ### setDocumentData

    public void setDocumentData(String sessionId, DocumentSoapDO documentData, String fileId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data. To update a document, documentData.getCurrentVersion needs to be set to 0.
    Specified by:
      `setDocumentData` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
    Throws:
      `RemoteException`

  - ### setDocumentData2

    public void setDocumentData2(String sessionId, Document2SoapDO documentData, String fileId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data. To update a document, documentData.getCurrentVersion needs to be set to 0.
    Specified by:
      `setDocumentData2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
    Throws:
      `RemoteException`

  - ### setDocumentData3

    public void setDocumentData3(String sessionId, Document3SoapDO documentData, String fileId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data. To update a document, documentData.getCurrentVersion needs to be set to 0.
    Specified by:
      `setDocumentData3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
    Throws:
      `RemoteException`

  - ### setDocumentDataWithAssociation

    public void setDocumentDataWithAssociation(String sessionId, DocumentSoapDO documentData, String fileId, String associationId, String associationComment) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data with Association.
    Specified by:
      `setDocumentDataWithAssociation` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the association
      `associationComment` - Comment for the association
    Throws:
      `RemoteException`

  - ### setDocumentDataWithAssociation2

    public void setDocumentDataWithAssociation2(String sessionId, Document2SoapDO documentData, String fileId, String associationId, String associationComment) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data with association.
    Specified by:
      `setDocumentDataWithAssociation2` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the association
      `associationComment` - Comment for the association
    Throws:
      `RemoteException`

  - ### setDocumentDataWithAssociation3

    public void setDocumentDataWithAssociation3(String sessionId, Document3SoapDO documentData, String fileId, String associationId, String associationComment) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets specified document data with association.
    Specified by:
      `setDocumentDataWithAssociation3` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentData` - Document data object.
      `fileId` - Uploaded file id (through FileStorageApp or SimpleFileStorageApp service).
      `associationId` - The id of the association
      `associationComment` - Comment for the association
    Throws:
      `RemoteException`

  - ### getDocumentFileId

    public String getDocumentFileId(String sessionId, String documentId, int documentVersion) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Returns a the file id associated with the document file.
    Specified by:
      `getDocumentFileId` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - document id.
      `documentVersion` - document version number (specify zero for current version).
    Returns:
      File storage id (for download using FileStorageService or SimpleFileStorageService).
    Throws:
      `RemoteException`

  - ### getDocumentVersions

    public Document2SoapList getDocumentVersions(String sessionId, String documentId, boolean includeDeletedVersions) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Lists all the versions of a document.
    Specified by:
      `getDocumentVersions` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - SOAP session id.
      `documentId` - Document id.
      `includeDeletedVersions` - Flag to indicate if the deleted versions of the document are to be fetched.
    Returns:
      Document list.
    Throws:
      `RemoteException`

  - ### deleteDocumentByVersions

    public void deleteDocumentByVersions(String sessionId, String documentId, int[] versionNumbers) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Deletes particular version(s) of a document.Locked document version(s) cannot be deleted
    Specified by:
      `deleteDocumentByVersions` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `documentId` - Document id.
      `versionNumbers` - Versions of the document to be deleted
    Throws:
      `RemoteException`

  - ### addTextField

    public void addTextField(String sessionId, String projectId, String fieldName, int displayColumns, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String defaultValue, String helpText, String pattern) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom text field to documents.
    Specified by:
      `addTextField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `displayColumns` - the width of the display area
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `defaultValue` - default value
      `helpText` - The help text for the field
      `pattern` - The field validation pattern
    Throws:
      `RemoteException`

  - ### addSingleSelectChildField

    public void addSingleSelectChildField(String sessionId, String projectId, String fieldName, String[] fieldValues, String parentFieldId, SoapNamedValues parentChildFieldValueMap, String helpText) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom single select field to documents.
    Specified by:
      `addSingleSelectChildField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `fieldValues` - Array of valid field values
      `parentFieldId` - The id of the parent field
      `parentChildFieldValueMap` - soapNamedValues which keeps mapping between parent field values and child values
      `helpText` - the help text for the field
    Throws:
      `RemoteException`

  - ### addSingleSelectField

    public void addSingleSelectField(String sessionId, String projectId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String defaultValue, String helpText) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom single select field to documents.
    Specified by:
      `addSingleSelectField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `fieldValues` - Array of valid field values
      `defaultValue` - default value
      `helpText` - the help text for the field
    Throws:
      `RemoteException`

  - ### addMultiSelectField

    public void addMultiSelectField(String sessionId, String projectId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] fieldValues, String[] defaultValues, String helpText) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom multi select field to documents.
    Specified by:
      `addMultiSelectField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `fieldValues` - possible values
      `defaultValues` - default values
      `helpText` - the help text for the field
    Throws:
      `RemoteException`

  - ### addUserSelectField

    public void addUserSelectField(String sessionId, String projectId, String fieldName, int displayLines, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String[] defaultValues, String userFilter, String helpText) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom User selection field to documents.
    Specified by:
      `addUserSelectField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `displayLines` - the height of the display area
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `defaultValues` - default values for this field. Must be valid usernames
      `userFilter` - is the filter
      `helpText` - The help text of the field
    Throws:
      `RemoteException`
    See Also:
      - `DocumentFolderFieldSoapDO.FIELD_USER_FILTER_PROJECT_MEMBER`
      - `DocumentFolderFieldSoapDO.FIELD_USER_FILTER_ALL`

  - ### addDateField

    public void addDateField(String sessionId, String projectId, String fieldName, boolean isRequired, boolean isDisabled, boolean isHiddenOnCreate, String helpText) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a custom Date field to documents.
    Specified by:
      `addDateField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the field to.
      `fieldName` - the name of the field
      `isRequired` - if the field is required
      `isDisabled` - if the field is disabled
      `isHiddenOnCreate` - if the field is hidden when first created
      `helpText` - the help text of the field
    Throws:
      `RemoteException`

  - ### getFields

    public DocumentFolderFieldSoapDO[] getFields(String sessionId, String projectId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Returns the custom/flex-fields associated with the given project's document root folder.
    Specified by:
      `getFields` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project for which to return the document fields information.
    Returns:
      Array of all field values.
    Throws:
      `RemoteException`

  - ### setField

    public void setField(String sessionId, DocumentFolderFieldSoapDO fieldData) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets a custom/flex-field.
    Specified by:
      `setField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `fieldData` - the custom/flex-field to associate with a specific folder
    Throws:
      `RemoteException`
    See Also:
      - `FaultSummary`

  - ### deleteField

    public void deleteField(String sessionId, String fieldId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Deletes a custom/flex-field.
    Specified by:
      `deleteField` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `fieldId` - the id of the field to delete
    Throws:
      `RemoteException`

  - ### addSeparator

    public void addSeparator(String sessionId, String projectId, String separatorType, String separatorLabel) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Adds a separator to a document root folder.
    Specified by:
      `addSeparator` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which to add the separator to.
      `separatorType` - the type of the separator
      `separatorLabel` - the label of the separator
    Throws:
      `RemoteException`

  - ### deleteSeparator

    public void deleteSeparator(String sessionId, String layoutId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Deletes a separator of a document root folder layout.
    Specified by:
      `deleteSeparator` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `layoutId` - the layout id of the separator. To get the layout id, use getOrderedDocumentFolderFields().
    Throws:
      `RemoteException`

  - ### getOrderedDocumentFields

    public OrderedDocumentFolderFieldSoapList getOrderedDocumentFields(String sessionId, String projectId) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Returns all the custom/flex-fields and the separators associated with the given project's document root folder with layout information.
    Specified by:
      `getOrderedDocumentFields` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project for which to return the document fields information.
    Returns:
      Array of all fields and separators.
    Throws:
      `RemoteException`

  - ### reorderDocumentFields

    public void reorderDocumentFields(String sessionId, String projectId, String[] layoutIds) throws RemoteException
    Description copied from interface: `IDocumentAppSoap`
    Sets a new order of the fields and the separators within the given project's document root folder.
    Specified by:
      `reorderDocumentFields` in interface `IDocumentAppSoap`
    Parameters:
      `sessionId` - User session id.
      `projectId` - The project in which all the document fields and the separators belong to.
      `layoutIds` - An array of layout ids which can be obtained by getOrderedDocumentFields().
    Throws:
      `RemoteException`